/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.system.action;

import jp.mosp.common.CommonConst;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.utils.VariousUtil;
import jp.mosp.kintai.common.action.KintaiCommonAction;
import jp.mosp.kintai.common.dao.MYakusyokuDao;
import jp.mosp.kintai.common.dto.MYakusyokuDto;
import jp.mosp.system.vo.YakusyokuMasterCardVo;

/**
 * @author yoshida
 *
 */
public class YakusyokuMasterCardAction extends KintaiCommonAction {
	
	// コマンド
	private static final String	CMD_YAKUSYOKU_MASTER_CARD_SHOW		= "S2205";	// 表示(追加)
	private static final String	CMD_YAKUSYOKU_MASTER_CARD_SELECT	= "S2206";	// 表示(選択)
	private static final String	CMD_YAKUSYOKU_MASTER_CARD_INSERT	= "S2207";	// 登録
	private static final String	CMD_YAKUSYOKU_MASTER_CARD_UPDATE	= "S2208";	// 更新
	private static final String	CMD_YAKUSYOKU_MASTER_CARD_DELETE	= "S2209";	// 削除
																				
	
	/**
	 * コンストラクタ
	 */
	public YakusyokuMasterCardAction() {
		super();
	}
	
	public void action() throws Exception {
		// VOの取得及び設定
		prepareVo();
		// 初期処理
		init();
		// コマンド毎の処理
		if (cmd.equals(CMD_YAKUSYOKU_MASTER_CARD_SHOW)) {
			// 表示
			show();
		} else if (cmd.equals(CMD_YAKUSYOKU_MASTER_CARD_SELECT)) {
			// 表示(キーで情報を検索)
			select();
		} else if (cmd.equals(CMD_YAKUSYOKU_MASTER_CARD_INSERT)) {
			// 新規登録
			insert();
		} else if (cmd.equals(CMD_YAKUSYOKU_MASTER_CARD_UPDATE)) {
			// 更新
			update();
		} else if (cmd.equals(CMD_YAKUSYOKU_MASTER_CARD_DELETE)) {
			// 削除
			delete();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new YakusyokuMasterCardVo();
	}
	
	@Override
	protected void init() throws Exception {
		// DBコネクション取得
		getConnection();
		// SYSTEM権限確認
		confirmSystemAuth();
		YakusyokuMasterCardVo vo = (YakusyokuMasterCardVo)getVo();
		// 等級区分プルダウンリスト作成
		vo.aryPltTokyu = getMosPCodeArray(CommonConst.TID_GRADE);
		// 役職手当区分プルダウンリスト（有無＋給与情報単価）作成
		vo.aryPltExistence1 = VariousUtil.getPositionAllowanceType1();
		// 役職手当区分プルダウンリスト（有無＋固定単価）作成
		vo.aryPltExistence2 = VariousUtil.getPositionAllowanceType2();
		// 役職手当区分プルダウンリスト（有無＋給与情報単価＋固定単価）作成
		vo.aryPltExistence3 = VariousUtil.getPositionAllowanceType3();
		// 手当名称リスト作成
		vo.setAryAllowance(getMosPCodeArray(CommonConst.TID_ALLOWANCE_NAME));
	}
	
	@Override
	protected void show() {
		YakusyokuMasterCardVo vo = (YakusyokuMasterCardVo)getVo();
		vo.setDefaultValues();
		vo.setMode(YakusyokuMasterCardVo.MODE_INSERT);
	}
	
	@Override
	protected void select() throws Exception {
		YakusyokuMasterCardVo vo = (YakusyokuMasterCardVo)getVo();
		// データの取得
		MYakusyokuDto dto = part().position().getPositionInfo(key1, key2);
		chkExist(dto);
		// VOに情報をセット
		vo.setFields(dto);
		setMode();
		// セッションにDTOをセット
		setSessionDto(dto);
	}
	
	@Override
	protected void insert() throws Exception {
		YakusyokuMasterCardVo vo = (YakusyokuMasterCardVo)getVo();
		vo.setParams(request);
		// パラメータの妥当性確認
		vo.validate();
		// DAOの準備
		MYakusyokuDao dao = part().position().getMYakusyokuDao();
		// DTOの準備
		MYakusyokuDto dto = new MYakusyokuDto();
		vo.setDtoFields(dto);
		// 存在チェック
		chkDuplicate(dao.findForKey(dto.getYcode(), dto.getTokyu()));
		// データの挿入
		dao.insert(dto);
		// DTOの再取得
		MYakusyokuDto retDto = dao.findForKey(dto.getYcode(), dto.getTokyu());
		chkInsert(retDto);
		// 等級無しの存在を確認
		if (!chkExistDto(dao.findForKey(dto.getYcode(), CommonConst.NAM_COMMON_INTEGER_INITIAL_VALUE))) {
			MYakusyokuDto nonGradeDto = dto;
			nonGradeDto.setTokyu(CommonConst.NAM_COMMON_INTEGER_INITIAL_VALUE);
			// データの挿入		
			dao.insert(nonGradeDto);
			// DTOの再取得
			nonGradeDto = dao.findForKey(nonGradeDto.getYcode(), nonGradeDto.getTokyu());
			chkInsert(nonGradeDto);
		}
		// コミット
		commit();
		// モード設定
		setMode();
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_INSERT, ""));
		// セッションにDTOをセット
		setSessionDto(retDto);
	}
	
	@Override
	protected void update() throws Exception {
		// DTOの取得
		MYakusyokuDto dto = (MYakusyokuDto)getSessionDto();
		YakusyokuMasterCardVo vo = (YakusyokuMasterCardVo)getVo();
		vo.setParams(request);
		// 等級区分取得
		vo.setPltTokyu(dto.getTokyu());
		// パラメータの妥当性確認
		vo.validate();
		// DAOの準備
		MYakusyokuDao dao = part().position().getMYakusyokuDao();
		// DTOの準備
		vo.setDtoFields(dto);
		// 排他確認
		chkExclusive(dto, dao.findForUpdate(dto.getYcode(), dto.getTokyu()));
		// データの更新
		dao.update(dto);
		// DTOの再取得
		MYakusyokuDto retDto = dao.findForKey(dto.getYcode(), dto.getTokyu());
		chkUpdate(retDto);
		// コミット
		commit();
		// モード設定
		setMode();
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_UPDATE, ""));
		// セッションにDTOをセット
		setSessionDto(retDto);
	}
	
	/**
	 * データ削除
	 * @throws Exception 	例外処理が発生した場合
	 */
	private void delete() throws Exception {
		// DTOの取得
		MYakusyokuDto dto = (MYakusyokuDto)getSessionDto();
		YakusyokuMasterCardVo vo = (YakusyokuMasterCardVo)getVo();
		// データの更新
		part().position().getMYakusyokuDao().delete(dto);
		// コミット
		commit();
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_DELETE, ""));
	}
	
	/**
	 * モード設定
	 * @throws Exception 	例外処理が発生した場合
	 */
	private void setMode() throws Exception {
		YakusyokuMasterCardVo vo = (YakusyokuMasterCardVo)getVo();
		// モード設定
		if (hasSystemAuth()) {
			vo.setMode(YakusyokuMasterCardVo.MODE_SYSTEM);
		} else {
			vo.setMode(YakusyokuMasterCardVo.MODE_UPDATE);
		}
	}
	
}
